# $Revision: 1.52 $, $Date: 2007/04/20 20:58:04 $
# TODO:
# - pldized init scripts
# - script for rc-boot
#
# Conditional build:
%bcond_with	pae		# build with PAE (HIGHMEM64G) support
%bcond_with	hvm		# build with hvm (full virtualization) support
#
Summary:	Xen - a virtual machine monitor
Summary(pl.UTF-8):	Xen - monitor maszyny wirtualnej
Name:		xen
%define		_major	3.0.4
%define		_minor	1
Version:	%{_major}_%{_minor}
Release:	0.5BL1
License:	GPL
Group:		Applications/System
Source0:	http://bits.xensource.com/oss-xen/release/%{_major}-%{_minor}/src.tgz/%{name}-%{version}-src.tgz
# Source0-md5:	e85e16ad3dc354338e3ac4a8951f9649
Source1:	%{name}-xend.init
Source2:	%{name}-xendomains.init
Patch0:		%{name}-python_scripts.patch
Patch1:		%{name}-bash_scripts.patch
#Patch2:		%{name}-bridge_setup.patch
Patch3:		%{name}-reisermodule.patch
Patch4:		%{name}-gcc.patch
Patch5:		%{name}-blktap-no-aio-epoll.patch
Patch6:		%{name}-BL.patch
URL:		http://www.cl.cam.ac.uk/Research/SRG/netos/xen/index.html
BuildRequires:	curl-devel
BuildRequires:	e2fsprogs-devel
BuildRequires:	latex2html
BuildRequires:	libidn-devel
BuildRequires:	ncurses-devel
BuildRequires:	python-devel
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	tetex-dvips
BuildRequires:	tetex-format-latex
BuildRequires:	tetex-latex-psnfss
BuildRequires:	transfig
BuildRequires:	which
BuildRequires:	zlib-devel
%{?with_hvm:BuildRequires:	bcc}
Requires(post,preun):	/sbin/chkconfig
Requires:	ZopeInterface
Requires:	bridge-utils
Requires:	kernel(xen0) >= 3.0.4
Requires:	losetup
Requires:	rc-scripts
Obsoletes:	xen-doc
ExclusiveArch:	%{ix86} %{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_version	%(echo %{version} |tr _ -)

%ifnarch i686 athlon pentium3 pentium4
%undefine	with_pae
%endif

%description
This package contains the Xen hypervisor and Xen tools, needed to run
virtual machines on x86 systems, together with the kernel-xen*
packages. Information on how to use Xen can be found at the Xen
project pages.

Virtualisation can be used to run multiple versions or multiple Linux
distributions on one system, or to test untrusted applications in a
sandboxed environment. Note that the Xen technology is still in
development, and this RPM has received extremely little testing. Don't
be surprised if this RPM eats your data, drinks your coffee or makes
fun of you in front of your friends.

%description -l pl.UTF-8
Ten pakiet zawiera nadzorcę oraz narzędzia Xen, potrzebne do
uruchamiania wirtualnych maszyn w systemach x86, wraz z pakietami
kernel-xen*. Informacje jak używać Xena można znaleźć na stronach
projektu.

Wirtualizacja może być używana do uruchamiania wielu wersji lub wielu
dystrybucji Linuksa na jednym systemie lub do testowania nie zaufanych
aplikacji w odizolowanym środowisku. Należy zauważyć, że technologia
Xen jest ciągle rozwijana, a ten RPM był słabo testowany. Nie należy
być zdziwionym, jeśli ten pakiet zje dane, wypije całą kawę czy będzie
się wyśmiewał w obecności przyjaciół.

%package libs
Summary:	xen libraries
Summary(pl.UTF-8):	Biblioteki xena
Group:		Libraries

%description libs
xen libraries.

%description libs -l pl.UTF-8
Biblioteki xena.

%package devel
Summary:	Header files for xen
Summary(pl.UTF-8):	Pliki nagłówkowe xena
Group:		Development/Libraries
Requires:	%{name}-libs = %{epoch}:%{version}-%{release}

%description devel
Header files for xen.

%description devel -l pl.UTF-8
Pliki nagłówkowe xena.

%package static
Summary:	Static xen libraries
Summary(pl.UTF-8):	Statyczne biblioteki xena
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}

%description static
Static xen libraries.

%description static -l pl.UTF-8
Statyczne biblioteki xena.

%prep
%setup -q -n %{name}-%{version}-src
%patch0 -p1
%patch1 -p1
#%patch2 -p1
#%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

find . -iregex .*.orig -exec rm {} \;

chmod -R u+w .


%build
CFLAGS="%{rpmcflags} -I/usr/include/ncurses" \
CXXFLAGS="%{rpmcflags} -I/usr/include/ncurses" \
%{__make} xen tools docs \
	%{?with_pae:XEN_TARGET_X86_PAE=y} \
	CC="%{__cc}" \
	CXX="%{__cxx}"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/var/run/{xen-hotplug,xend,xenstored}

%{__make} install-xen install-tools install-docs \
	%{?with_pae:XEN_TARGET_X86_PAE=y} \
	DESTDIR=$RPM_BUILD_ROOT \
	XEN_PYTHON_NATIVE_INSTALL=1

install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/xend
install %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/xendomains

install -d $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}/xend-db/{domain,vnet}
install -d $RPM_BUILD_ROOT%{_sharedstatedir}/xen/save

rm -f $RPM_BUILD_ROOT%{_includedir}/%{name}/COPYING

%{py_comp} $RPM_BUILD_ROOT%{py_sitedir}
%{py_ocomp} $RPM_BUILD_ROOT%{py_sitedir}
%{py_comp} $RPM_BUILD_ROOT%{py_sitescriptdir}
%{py_ocomp} $RPM_BUILD_ROOT%{py_sitescriptdir}


find $RPM_BUILD_ROOT%{py_sitedir} -name '*.py' -exec rm "{}" ";"
#find $RPM_BUILD_ROOT%{py_sitescriptdir} -name '*.py' -exec rm "{}" ";"
rm -rf $RPM_BUILD_ROOT%{_docdir}/xen
rm -rf $RPM_BUILD_ROOT/etc/init.d

cp -a dist/install/etc/udev $RPM_BUILD_ROOT%{_sysconfdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add xend
/sbin/chkconfig --add xendomains

%preun
if [ "$1" = "0" ]; then
	%service xend stop
	/sbin/chkconfig --del xend

	%service xendomains stop
	/sbin/chkconfig --del xendomains
fi

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc COPYING README docs/misc/*
%doc docs/html/*
/boot/%{name}-syms-%{_version}
/boot/%{name}-%{_version}.gz
/boot/%{name}.gz
%attr(754,root,root) /etc/rc.d/init.d/*
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/*
%config(noreplace) %verify(not md5 mtime size) /etc/udev/*
#%attr(755,root,root) /etc/hotplug/*
%dir %{_sysconfdir}/xen
%attr(755,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/qemu-ifup
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/*.*
#%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/b*
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/xmexample[12]
%dir %{_sysconfdir}/xen/auto
%dir %{_sysconfdir}/xen/scripts
%attr(755,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/scripts/*
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_sbindir}/*
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/bin
%attr(744,root,root) %{_libdir}/%{name}/bin/*
%if %{with hvm}
%dir %{_prefix}/lib/%{name}/boot
%attr(744,root,root) %{_prefix}/lib/%{name}/boot/hvmloader
%endif
%{_datadir}/xen
%{py_sitedir}/fsimage.so
%{py_sitedir}/grub
%dir %{py_sitedir}/%{name}
%dir %{py_sitedir}/%{name}/lowlevel
%{py_sitedir}/%{name}/lowlevel/*.py*
%attr(755,root,root) %{py_sitedir}/%{name}/lowlevel/*.so
%{py_sitedir}/%{name}/sv
%{py_sitedir}/%{name}/util
%{py_sitedir}/%{name}/web
%{py_sitedir}/%{name}/xend
%{py_sitedir}/%{name}/xm
%{py_sitedir}/%{name}/*.py*
#%{py_sitescriptdir}/*
%{_mandir}/man?/*
%{_sharedstatedir}/xen
%{_sharedstatedir}/xenstored
%dir /var/run/xen-hotplug
%dir %attr(700,root,root) /var/run/xend
%dir /var/run/xenstored

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/lib*.so.*
%dir %{_libdir}/fs
%dir %{_libdir}/fs/ext2fs-lib
%dir %{_libdir}/fs/reiserfs
%dir %{_libdir}/fs/ufs
%attr(755,root,root) %{_libdir}/fs/*/*.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/lib*.so
%{_includedir}/*

%files static
%defattr(644,root,root,755)
%{_libdir}/lib*.a

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: xen.spec,v $
Revision 1.52BL1  2008/02/28 17:52:24  bartoszl@ics.p.lodz.pl
- requires kernel(xen0) >= 3.0.4

Revision 1.52BL  2007/10/05 20:58:04  bartoszl@ics.p.lodz.pl
- fixed passing irq to domU, see http://lists.xensource.com/archives/html/xen-devel/2007-06/msg00972.html
- fixed hvmbuilder location
- added brouter scripts
- added parallel support

Revision 1.52  2007/04/20 20:58:04  qboosh
- added x8664 to EA (just builds on ac-amd64)

Revision 1.51  2007/04/20 09:55:30  qboosh
- separated -libs
- fs modules moved from -devel to -libs

Revision 1.50  2007/04/20 09:53:01  qboosh
- Twisted and libX11 are not used in this version

Revision 1.49  2007/04/19 22:55:08  qboosh
- use system libext2fs

Revision 1.48  2007/02/26 10:00:44  grzegorz
- added xen-blktap-no-aio-epoll.patch to allow tap:aio VBD
- rel 0.5

Revision 1.47  2007/02/12 22:09:22  glen
- tabs in preamble

Revision 1.46  2007/02/12 01:06:38  baggins
- converted to UTF-8

Revision 1.45  2007/02/10 22:42:19  alucard
- BR bin86 already needed by BR bcc...

Revision 1.44  2007/02/10 22:30:46  alucard
- BRs for hvm extensions

Revision 1.43  2007/02/10 17:33:59  alucard
- up to 3.0.4-1

Revision 1.42  2006/12/07 19:40:51  adamg
- unify pae bcond with kernel.spec

Revision 1.41  2006/11/25 23:40:07  shadzik
- don't try to package py_sitescriptdir which doesn't exist

Revision 1.40  2006/11/25 23:00:44  shadzik
- ups, re-add BR

Revision 1.39  2006/11/24 00:37:59  shadzik
- fix reisermodule build

Revision 1.38  2006/11/18 19:19:58  shadzik
- install missing dir /var/lib/xen/save and kill its duplicate in %file
- builds

Revision 1.37  2006/11/18 19:07:07  shadzik
- sed->tr (if you insit on using sed, give an apropriate BR)

Revision 1.36  2006/11/11 23:27:36  domelu
- missing dir /var/lib/xen/save

Revision 1.35  2006/11/01 13:08:42  grzegorz
- up to 3.0.3_0

Revision 1.34  2006/09/02 20:33:32  glen
- R(post): ldconfig

Revision 1.33  2006/08/19 13:05:23  adamg
- change Requires: kernel(xen) to Requires: kernel(xen0)

Revision 1.32  2006/07/26 14:19:03  adamg
- xen-xenstore-version.patch applied (fixes library soname)
- few more files added
- rel 0.3

Revision 1.31  2006/06/29 13:02:29  jajcus
- a patch added, which makes the bridge setup script work when the default route has 'onlink' attribute

Revision 1.30  2006/06/29 07:28:50  qboosh
- proper with_pae disabling

Revision 1.29  2006/06/29 06:30:46  jajcus
- enable PAE by default on archs supporting it

Revision 1.28  2006/06/28 08:28:58  jajcus
- with_pae bcond

Revision 1.27  2006/05/09 10:06:19  qboosh
- Obsoletes: xen-doc

Revision 1.26  2006/04/30 18:59:56  jajcus
- -doc subpackage removed, docs moved to %doc (a subpackage for a short
  documentation is overkill and installing documentation in %{_datadir} seems
  like a mistake)
- R: latex2html
- s,#!/bin/sh,#!/bin/bash, in many scripts -- they were written with Bash in mind
- s,#!/usr/bin/env python,#!/usr/bin/python, for all Python scripts
- Python scripts installed in %{py_scriptdir} and %{py_sitescriptdir}
- missing directories in /var/run added
- syms filename fixed
- many previously unpackaged files added to the package

Revision 1.25  2006/04/20 17:59:48  glen
- cosmetics

Revision 1.24  2006/04/20 17:58:55  glen
- use %service, add chkconfig deps

Revision 1.23  2006/04/19 12:26:42  cieciwa
- release 0.1,
- removed two patches
  Need more testing.

Revision 1.22  2006/04/19 12:12:39  cieciwa
- updated to version 3.0.2,
- requite kernel(xen)=%{_xen_version} - in this moment 3.0.2.

Revision 1.21  2005/09/01 17:27:03  paszczus
- real BR ; adapter removed it

Revision 1.20  2005/09/01 17:25:37  paszczus
- reverted (2.0.6 is back) cause linux-xen-2.0.6.patch needs update
- added BR: rpm-pythonprov
- adaptarized

Revision 1.16  2005/06/16 21:33:18  qboosh
- sorted deps

Revision 1.15  2005/06/16 21:15:29  speedy
- BR: which Req: bridge-utils

Revision 1.14  2005/06/13 12:45:34  speedy
- rel 0.3
- -scripts %patch

Revision 1.13  2005/06/12 22:38:32  speedy
- more and more...

Revision 1.12  2005/06/12 20:49:05  speedy
- Req: losetup

Revision 1.11  2005/06/12 18:24:54  speedy
- twisted.protocols.http has moved to twisted.web.http.
- missing directories

Revision 1.10  2005/06/10 11:53:08  speedy
- fixed BR

Revision 1.9  2005/06/10 10:01:41  speedy
- stable on HEAD, devel on DEVEL...
- version 2.0.6
- more BR

Revision 1.8  2005/04/20 14:24:36  paszczus
- updated to 20050420 snap
- changed Version number from 2 to 3 (this is 3.0-devel)
- builds.

Revision 1.7  2005/03/29 22:54:54  qboosh
- pl for -devel,-static; fixed -devel desc (what documentation?)

Revision 1.6  2005/03/29 16:27:04  arekm
- TODO: script for rc-boot

Revision 1.5  2005/03/29 16:25:32  arekm
- up to 20050329; add init scripts

Revision 1.4  2004/12/22 22:02:54  qboosh
- some files fixes (further needed), may require build/install fixes

Revision 1.3  2004/12/22 18:56:36  averne
- 755 for /etc/rc.d/init.d/xen*

Revision 1.2  2004/12/22 15:37:28  averne
- added BR: curl-devel, python-devel
- fixed to build

Revision 1.1  2004/12/22 14:37:25  arekm
- raw

* Sun Dec  5 2004 Rik van Riel
- grab new Xen tarball (with wednesday's patch already included)

* Wed Dec  1 2004 Rik van Riel <riel@redhat.com>
- fix up Che's spec file a little bit
- create patch to build just Xen, not the kernels

* Wed Dec 01 2004 Che
- initial rpm release
